unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, ShellCtrls, DB, DBTables, Grids, DBGrids,
  StdCtrls;

type
  TMainForm = class(TForm)
    SB: TStatusBar;
    Table1: TTable;
    DataSource1: TDataSource;
    paExplorerBG: TPanel;
    Splitter1: TSplitter;
    paDataViewBG: TPanel;
    paExplorer: TPanel;
    paDataView: TPanel;
    Bevel1: TBevel;
    stvExplorer: TShellTreeView;
    Bevel2: TBevel;
    DBGrid1: TDBGrid;
    paTableInfoBG: TPanel;
    Bevel3: TBevel;
    paTableInfo: TPanel;
    laType: TLabel;
    laTableType: TLabel;
    laPathTitle: TLabel;
    laPath: TLabel;
    laRecordsTitle: TLabel;
    laRecords: TLabel;
    laRecNoTitle: TLabel;
    laRecNo: TLabel;
    laFieldsTitle: TLabel;
    laFields: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure stvExplorerChange(Sender: TObject; Node: TTreeNode);
    procedure stvExplorerAddFolder(Sender: TObject; AFolder: TShellFolder;
      var CanAdd: Boolean);
    procedure Table1AfterOpen(DataSet: TDataSet);
    procedure Table1AfterScroll(DataSet: TDataSet);
    procedure Table1AfterClose(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  MainForm.Caption := Application.Title;
  stvExplorer.Font := Screen.IconFont;
end;

procedure TMainForm.stvExplorerChange(Sender: TObject; Node: TTreeNode);
var
  Path: string;
begin
  if not stvExplorer.SelectedFolder.IsFolder then
  begin
    Path := stvExplorer.SelectedFolder.PathName;
    if (LowerCase(ExtractFileExt(Path)) = '.db') or
      (LowerCase(ExtractFileExt(Path)) = '.dbf') then
    begin
      Table1.Active := False;
      Table1.DatabaseName := ExtractFileDir(Path);
      Table1.TableName := ExtractFileName(Path);
      try
        Table1.Active := True;
      except
        MessageBox(MainForm.WindowHandle,
          PChar(Format('Table %s couldn''t be opened', [Path])),
          PChar('Error'), MB_ICONERROR or MB_OK);
      end;
    end else
      Table1.Active := False;
  end else
    Table1.Active := False;  
end;

procedure TMainForm.stvExplorerAddFolder(Sender: TObject;
  AFolder: TShellFolder; var CanAdd: Boolean);
begin
  with AFolder do
  begin
    CanAdd := False;
    if IsFolder then CanAdd := True;
    if ((not IsFolder) and (LowerCase(ExtractFileExt(PathName)) = '.db') or (LowerCase(ExtractFileExt(PathName)) = '.dbf')) then
      CanAdd := True;
  end;
end;

procedure TMainForm.Table1AfterOpen(DataSet: TDataSet);
var
  Ext: string;
begin
  Ext := LowerCase(ExtractFileExt(Table1.TableName));
  if (Ext = '') or (Ext = '.db') then laTableType.Caption := Format('Paradox %d', [Table1.TableLevel]);
  if (Ext = '.dbf') then laTableType.Caption := Format('dBase %d', [Table1.TableLevel]);
  laPath.Caption := stvExplorer.SelectedFolder.PathName;
  laRecords.Caption := IntToStr(Table1.RecordCount);
  laRecNo.Caption := IntToStr(Table1.RecNo);
  laFields.Caption := IntToStr(Table1.Fields.Count);
end;

procedure TMainForm.Table1AfterScroll(DataSet: TDataSet);
begin
  laRecNo.Caption := IntToStr(Table1.RecNo);
end;

procedure TMainForm.Table1AfterClose(DataSet: TDataSet);
begin
  laTableType.Caption := 'No file selected';
  laPath.Caption := 'No file selected';
  laRecords.Caption := 'No file selected';
  laRecNo.Caption := 'No file selected';
  laFields.Caption := 'No file selected';  
end;

end.
